<template>
    <div>
        <ValidationObserver v-slot="{ handleSubmit }">
            <form @submit.prevent="handleSubmit(onLogin)">
                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="email"
                        rules="required|email"
                    >
                        <input
                            id="email"
                            v-model="email"
                            class="form-control"
                            name="email"
                            placeholder="Email"
                            type="email"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <ValidationProvider
                        v-slot="{ errors }"
                        name="password"
                        rules="required"
                    >
                        <input
                            id="password"
                            v-model="password"
                            class="form-control"
                            name="password"
                            placeholder="Password"
                            type="password"
                        />
                        <div class="error-message">{{ errors[0] }}</div>
                    </ValidationProvider>
                </div>

                <div class="mt-4">
                    <button class="btn btn-fluid text-uppercase" type="submit">
                        Login
                    </button>
                </div>
            </form>
        </ValidationObserver>

        <div class="mt-4">
            <a href="#" @click="switchComponent('ForgotPasswordForm')"> Forget Password? </a>
        </div>
    </div>
</template>

<script>
import AuthService from "@/services/AuthService";

export default {
    name: "login-form-component",
    components: {},
    data() {
        return {
            email: "",
            password: "",
        };
    },
    methods: {
        /**
         * Show loading overlay.
         */
        showLoadingOverlay() {
            this.$JsLoadingOverlay.show({'spinnerIcon': 'ball-scale-multiple'});
        },

        /**
         * Hide loading overlay.
         */
        hideLoadingOverlay() {
            this.$JsLoadingOverlay.hide();
        },

        /**
         * Login user into application.
         */
        onLogin() {
            this.$JsLoadingOverlay.show();

            let vm = this;

            // Login into application.
            this.authService.login(this.email, this.password).then((result) => {
                this.hideLoadingOverlay();

                if (result.status !== 200) {
                    let message = 'Oops! Something went wrong.';

                    if (result.response !== undefined) {
                        message = result.response.data.message;
                    }

                    vm.$swal({
                        title: "Error!",
                        text: message,
                        icon: "error",
                        confirmButtonText: "OK"
                    });
                } else {
                    this.hideLoadingOverlay();

                    window.localStorage.setItem('token', result.data.data.tokens.idToken);
                    window.localStorage.setItem('refresh_token', result.data.data.tokens.refreshToken);
                    window.localStorage.setItem('user', JSON.stringify(result.data.data.user));

                    vm.$router.push('/dashboard/preparations/dpnr');
                }
            });
        },

        /**
         * Switch component.
         *
         * @param componentName
         */
        switchComponent(componentName) {
            this.$emit("switchComponent", componentName);
        }
    },
    computed: {
        /**
         * Create AuthService instance.
         *
         * @returns {AuthService}
         */
        authService: function () {
            return new AuthService(true);
        }
    },
};
</script>
